---
title: CacheStorage.delete()
slug: Web/API/CacheStorage/delete
tags:
  - API
  - CacheStorage
  - Experimental
  - Method
  - Reference
  - Service Workers
  - ServiceWorker
  - delete
---
<p>{{APIRef("Service Workers API")}}</p>

<p>The <code><strong>delete</strong></code><strong><code>()</code></strong> method of the {{domxref("CacheStorage")}} interface finds the {{domxref("Cache")}} object matching the <code>cacheName</code>, and if found, deletes the {{domxref("Cache")}} object and returns a {{jsxref("Promise")}} that resolves to <code>true</code>. If no {{domxref("Cache")}} object is found, it resolves to <code>false</code>.</p>

<p>You can access <code>CacheStorage</code> through the global {{domxref("WindowOrWorkerGlobalScope.caches", "caches")}} property.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">caches.delete(<em>cacheName</em>).then(function(<em>boolean</em>) {
  // your cache is now deleted
});
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>cacheName</code></dt>
 <dd>The name of the cache you want to delete.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>a {{jsxref("Promise")}} that resolves to <code>true</code> if the {{domxref("Cache")}} object is found and deleted, and <code>false</code> otherwise.</p>

<h2 id="Examples" style="line-height: 30px; font-size: 2.14285714285714rem;">Examples</h2>

<p>In this code snippet we wait for an activate event, and then run a {{domxref("ExtendableEvent.waitUntil","waitUntil()")}} block that clears up any old, unused caches before a new service worker is activated. Here we have an array of cache names we want to keep (<code>cachesToKeep</code>). We return the keys of the caches in the {{domxref("CacheStorage")}} object using {{domxref("CacheStorage.keys")}}, then check each key to see if it is in the array. If not, we delete it using <code>delete()</code>.</p>

<pre class="brush: js">this.addEventListener('activate', function(event) {
  var cachesToKeep = ['v2'];

  event.waitUntil(
    caches.keys().then(function(keyList) {
      return Promise.all(keyList.map(function(key) {
        if (cachesToKeep.indexOf(key) === -1) {
          return caches.delete(key);
        }
      }));
    })
  );
});</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Service Workers', '#cache-storage-delete', 'CacheStorage: delete')}}</td>
   <td>{{Spec2('Service Workers')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CacheStorage.delete")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/ServiceWorker_API/Using_Service_Workers">Using Service Workers</a></li>
 <li>{{domxref("Cache")}}</li>
 <li>{{domxref("WindowOrWorkerGlobalScope.caches")}}</li>
</ul>
